#include "Vram.h"
#include "Chars.h"

extern const byte[] MonoPattern, ColorPattern;

static const byte[] PatternColorTable = {
	28, 3,
    16, 2,
    1, 3,
    1, 2,
	3, 1,
	4, 3,
    0xff
};


void InitVram()
{
    {
        byte pattern;
        ptr<byte> pSource, pPattern;
        pattern = 0;
        pSource = PatternColorTable;
        pPattern = MonoPattern;
        while (pSource[0] != 0xff) {
            byte count, color;
            count = *pSource; ++pSource;
            color = *pSource; ++pSource;
            SetPatternMono(pPattern, pattern, color, count);
            pattern += count;
            pPattern += ((word)count) << 2;
        }
        SetPatternColor(ColorPattern, pattern, 4 * 4);
    }
}


void Put2S(ptr<byte> pVram, ptr<byte> pChars)
{
    repeat (2) {
        repeat (2) {
            *pVram = *pChars; ++pVram;
            ++pChars;
        }
        pVram += VramWidth - 2;
    }
}


void Put2C(byte x, byte y, byte c)
{
    ptr<byte> pVram;
    pVram = VramPtr(x, y);
    repeat (2) {
        repeat (2) {
            *pVram = c; ++pVram;
            ++c;
        }
        pVram += VramWidth - 2;
    }
}


void Erase2(byte x, byte y)
{
    ptr<byte> pVram;
    pVram = VramPtr(x, y);
    repeat (2) {
        repeat (2) {
            *pVram = Char_Space; ++pVram;
        }
        pVram += VramWidth - 2;
    }
}
